﻿namespace WindowsFormsApplication3
{
    using System.Collections.Generic;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private List<MyClass> myValues_;
        private Dictionary<MyClass, string> nameMap_;
        private const string columnName_ = "column";
        public Form1()
        {
            InitializeComponent();
            nameMap_ = new Dictionary<MyClass, string>();
            myValues_ = new List<MyClass>();
            var myClass1 = new MyClass() { Value = 0 };
            myValues_.Add(myClass1);
            nameMap_.Add(myClass1, "Name1");
            var myClass2 = new MyClass() { Value = 1 };
            myValues_.Add(myClass2);
            nameMap_.Add(myClass2, "Name2");
            var myClass3 = new MyClass() { Value = 2, IsObsolete = true };
            myValues_.Add(myClass3);
            nameMap_.Add(myClass3, "Name3");
            InitGrid();
        }

        private void InitGrid()
        {
            var dataTable = new DataTable();
            dataTable.Columns.Add(columnName_, typeof(MyClass));
            var row = dataTable.NewRow();
            row[columnName_] = myValues_[2];
            dataTable.Rows.Add(row);

            var row2 = dataTable.NewRow();
            row2[columnName_] = myValues_[0];
            dataTable.Rows.Add(row2);

            grid_.DataSource = dataTable;
            grid_.DataBind();
            //var vl = new ValueList();
            //foreach (var myValue in myValues_.Where(_ => !_.IsObsolete))
            //{
            //    string name;
            //    nameMap_.TryGetValue(myValue, out name);
            //    vl.ValueListItems.Add(myValue, name);
            //}
            //grid_.DisplayLayout.Bands[0].Columns[columnName_].ValueList = vl;
            //grid_.DisplayLayout.Bands[0].Columns[columnName_].Width = 150;

            UltraDropDown dropDown = new UltraDropDown();
            dropDown.DataSource = myValues_;
            UltraGridColumn nameColumn = dropDown.DisplayLayout.Bands[0].Columns.Add(columnName_);
            dropDown.DisplayMember = columnName_;

            UltraGridColumn valueColumn = dropDown.DisplayLayout.Bands[0].Columns.Add("MyValue");
            valueColumn.DataType = typeof(MyClass);
            dropDown.ValueMember = "MyValue";

            foreach (UltraGridRow dropRow in dropDown.Rows)
            {
                string name;
                MyClass currentValue = (MyClass)dropRow.ListObject;
                nameMap_.TryGetValue(currentValue, out name);
                dropRow.Cells[columnName_].Value = name;
                dropRow.Cells["MyValue"].Value = currentValue;

                if ((bool)dropRow.Cells[1].Value)
                {
                    dropRow.Activation = Activation.Disabled;
                    dropRow.Hidden = true;
                }
            }

            dropDown.DisplayLayout.Bands[0].Columns["Value"].Hidden = true;
            dropDown.DisplayLayout.Bands[0].Columns["IsObsolete"].Hidden = true;
            dropDown.DisplayLayout.Bands[0].Columns["MyValue"].Hidden = true;

            grid_.DisplayLayout.Bands[0].Columns[columnName_].Width = 150;
            grid_.DisplayLayout.Bands[0].Columns[columnName_].ValueList = dropDown;
            grid_.DisplayLayout.Bands[0].Columns[columnName_].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
        }
    }

    class MyClass
    {
        public int Value { get; set; }
        public bool IsObsolete { get; set; }
    }
}
